       subroutine A1nd_wf(q0,qv,ksf,kt1,ks1,p_m,kt2,ks2,p_r,kt3,ks3,kj,
     &                                     wf1_re,wf1_im,md,ifl,irs)
******************************************************************
* inputs 
* q0 - virtual photon energy
* qv - virtual photon momentum
* kti - (i=1,2,3) isospins(1->proton,-1->neutron)
* ks1,ks2,ks3 - spin projection of 1,2,3 nucleon -1-> -1/2, 1-> 1/2
* kj - spin projection of he3 -1-> -1/2, 1-> 1/2
* idr - Flag of He3 WF (1,2 -> initialisation, 0->computation)
* md - method number in PV term, see  subroutine A1_z
* ifl - =1->pole case,= 2->PV case, 0 -> both
* irs = 22 pp rescattering, 21 pn rescattering
*       second digit indicates the isospin of the rescattered nucleon
* irs = 121 - np case - knocked-out neutron with rescattering off proton-r
* irs = 122 - np case - knocked-out neutron with rescattering off proton-s    
*
*inputs through common 
*/par/pi,pm,pmp,pmn,tm   : pi amd masses(constants)
*******************************************************************
        external phlnd, phund, un_1nd
        dimension p_m(3),p_r(3)
        common/par/pi,pm,pmp,pmn,tm,eb
	common/vphoton/Q2,q0c,qvc
	common/knocked/  p_f_x,  p_f_y,  p_f_z
        common/missing/  p_m_x,  p_m_y,  p_m_z
        common/recoil_r/ p_r_x,  p_r_y,  p_r_z
        common/recoil_s/ p_s_x,  p_s_y,  p_s_z
        common/conf/it1,is1,it2,is2,it3,is3,ij
        common/iflag/iflag
        common/enginv/s,its
        common/delta0/delta_r,delta_s
        common/pvstaff/accuracy,downlimit,uplimit 
        common/method/method
        common/emiss/ems
        common/spinf/isf
        common/reorim/imre

        its    = irs
        iflag  = ifl
        method = md
        isf    = ksf

        it1    = kt1
        is1    = ks1
        it2    = kt2
        is2    = ks2
        it3    = kt3
        is3    = ks3
        ij     = kj
        accuracy  =  0.1
        downlimit = -1.0
        uplimit   =  1.0
        Q2  = qv**2 - q0**2
        qvc = qv
        q0c = q0

        p_m_x =  p_m(1)
        p_m_y =  p_m(2)
        p_m_z =  p_m(3)

        p_m_v = sqrt(p_m_x**2 + p_m_y**2 + p_m_z**2)
        t_2m = sqrt(4.0*pm**2 + p_m_v**2)-2.0*pm

        p_r_x =  p_r(1)
        p_r_y =  p_r(2)
        p_r_z =  p_r(3)

        p_s_x = -(p_m_x + p_r_x)  
        p_s_y = -(p_m_y + p_r_y) 
        p_s_z = -(p_m_z + p_r_z) 

        p_f_x = p_m_x
        p_f_y = p_m_y
        p_f_z = p_m_z + qv

        p_f = sqrt(p_f_x**2 + p_f_y**2 + p_f_z**2)
        pr  = sqrt(p_r_x**2 + p_r_y**2 + p_r_z**2)
        ps  = sqrt(p_s_x**2 + p_s_y**2 + p_s_z**2)


        E_f = sqrt(pmp**2+p_f**2)
        E_r = sqrt(pmp**2+pr**2)
        E_s = sqrt(pmn**2+ps**2)
        T_r = E_r - pm
        T_s = E_s - pmn
        delta_r = q0/qv*(T_r + T_s + eb) 
     &          +(2.*pm*(T_r + T_s) + p_m_v**2 - (T_r+T_s)**2)/(2.0*qv)

*        delta_r = q0/qv*(ems+t_2m) 
*     &          + (2.*pm*(ems+t_2m) + p_m_v**2 - (ems+t_2m)**2)/(4.0*qv)
        delta_s = delta_r
**************************************************
* This block calculates the s of the NN system
**************************************************
        if(irs.eq.22)then          ! pp case
        s = 2*(pmp**2+E_f*E_r - p_f_x*p_r_x -p_f_y*p_r_y -p_f_z*p_r_z)
        elseif(irs.eq.21)then     ! pn case
        s = pmp**2+pmn**2+2.0*(E_f*E_s - 
     &                p_f_x*p_s_x -p_f_y*p_s_y -p_f_z*p_s_z) 
        endif

        if(irs.gt.23)then          ! np case
        E_f = sqrt(pmn**2+p_f**2)
        E_r = sqrt(pmp**2+pr**2)
        E_s = sqrt(pmp**2+ps**2)
        T_r = E_r - pmp
        T_s = E_s - pmp
        delta_r = q0/qv*(T_r + T_s + eb)
     &          + (2.*pm*(T_r + T_s) + p_m_v**2 - (T_r+T_s)**2)/(2.0*qv)

*        delta_r = q0/qv*(ems+t_2m) 
*     &          + (2.*pm*(ems+t_2m) + p_m_v**2  - (ems+t_2m)**2)/(4.0*qv)

        delta_s = delta_r
        if(irs.eq.121)then ! neutron rescatters off proton -r
        s = pmp**2+pmn**2+2.0*(E_f*E_r - 
     &                p_f_x*p_r_x -p_f_y*p_r_y -p_f_z*p_r_z)
        elseif(irs.eq.122)then ! neutron rescatters off proton -s
        s = pmp**2+pmn**2+2.0*(E_f*E_s - 
     &                p_f_x*p_s_x -p_f_y*p_s_y -p_f_z*p_s_z)
        endif
        endif
        
***************************************************************

        imre = 1
        eps = 0.10
        qa  = 0.0
        qb  = 1.
        sum_re = 0.0
        call gadap2(qa,qb,phlnd,phund,un_1nd,eps,sum_re) 

        imre = -1
        eps = 0.10
        qa  = 0.0
        qb  = 1.
        sum_im = 0.0
  	call gadap2(qa,qb,phlnd,phund,un_1nd,eps,sum_im)                

        wf1_re = sum_re
        wf1_im = sum_im         

        return
        end

        function phlnd(q)
	phlnd = 0.0
	return
	end
	function phund(q)
	phund = 2.0*acos(-1.0)
	return
	end

	function  un_1nd(q,phiq)
        dimension pv1(3), pv2(3)
        common/par/pi,pm,pmp,pmn,tm,eb
	common/vphoton/Q2,q0,qv
        common/missing/  p_m_x,  p_m_y,  p_m_z
        common/recoil_r/ p_r_x,  p_r_y,  p_r_z
        common/knocked/  p_f_x,  p_f_y,  p_f_z
 
        common/delta0/ delta_r, delta_s
        common/conf/kt1,ks1,kt2,ks2,kt3,ks3,kj
 	common/enginv/s,its
        common/iflag/iflag !iflag =1->pole case,= 2->PV case, 0 -> both
        common/pvstaff/accuracy,downlimit,uplimit 
        common/method/method
        common/spinf/ksf
        common/reorim/imre
        un_1nd = 0.0
        
	q_x      = q*cos(phiq)
	q_y      = q*sin(phiq)

 	pv1(3)   = p_m_z + delta_r
	pv1(2)   = p_m_y + q_y
	pv1(1)   = p_m_x + q_x
	p_1     = sqrt(pv1(1)**2+pv1(2)**2+pv1(3)**2)
*        write(6,*)delta_r,delta_s

                    ireg = 21
*       if(ktf.eq.-1)ireg = 12
*       sigma0   = 1.0 !sigma_en(p_m_x,p_m_y,p_m_z,ireg)
*       sigma1   =  1.0 !sigma_en(pv1(1),pv1(2),pv1(3),ireg)
*       rsg = sqrt(sigma1/sigma0)
        
        if (its.eq.22.or.its.eq.121) then
	pv2(3)   = p_r_z - delta_r
        pv2(2)   = p_r_y - q_y
	pv2(1)   = p_r_x - q_x
        ksri      = ks2
        ksrf      = ks2
        elseif(its.eq.21.or.its.eq.122) then
	pv2(3)   = p_r_z 
        pv2(2)   = p_r_y 
	pv2(1)   = p_r_x 
        ksri      = ks3
        ksrf      = ks3
        endif
	p_2     = sqrt(pv2(1)**2+pv2(2)**2+pv2(3)**2)
        E_2     = sqrt(pm**2 + p_2**2)

****************************************************
* Calculation of t_on and t_off
****************************************************
****************************************************
*        Third nucleon 
****************************************************
        pv3_x = -(pv1(1) + pv2(1))
        pv3_y = -(pv1(2) + pv2(2))
        pv3_z = -(pv1(3) + pv2(3))
        pv3 = sqrt(pv3_x**2 + pv3_y**2 + pv3_z**2)
        E_3 = sqrt(pm**2 + pv3**2)
 
	p_f = sqrt(p_f_x**2 + p_f_y**2 + p_f_z**2)
	e_f = sqrt(pm**2 + p_f**2)

	p_tf_x   = pv1(1) 
	p_tf_y   = pv1(2)
	p_tf_z   = pv1(3) + qv
	p_tf     = sqrt(p_tf_x**2 + p_tf_y**2 + p_tf_z**2) 
	e_tf_on  = sqrt(pm**2 + p_tf**2)
	e_tf_off = tm - E_2 - E_3 + q0

	delta_pf2 = (p_f_x-p_tf_x)**2 + (p_f_y-p_tf_y)**2
     &                                + (p_f_z-p_tf_z)**2

  	t_on  = (e_f - e_tf_on)**2  - delta_pf2
	t_off = (e_f - e_tf_off)**2 - delta_pf2



        un_1_re_pole = 0.0
        un_1_re_pv   = 0.0
        
        if (iflag.eq.1.or.iflag.eq.0) then
************************************************************************
*       Pole term
************************************************************************
        wfre = 0.0
        wfim = 0.0
           
	call wf_he3_nb(kt1,ks1,pv1,kt2,ks2,pv2,kt3,ks3,kj,wfre,wfim,0) 

*        call f_NN_on(s,t_on,f_NN_on_re,f_NN_on_im,its)

        ksfpr = -ksf


        ins = its

        if(its.eq.22)then
                    ins = 21
        if(kt2.eq.1)ins = 22
        elseif(its.eq.21)then
                    ins = 21
        if(kt3.eq.1)ins = 22
        endif



	ini = 1
*       call f_NN_sd(ksfpr,ksri,ksf,ksrf,s,t_on,f_on_re,f_on_im,ins,ini)
       call f_NN_sd(ksfpr,-1,ksf,1,s,t_on,f_on_re,f_on_im,ins,ini)



        if(imre.gt.0)then ! real part      
        un_1_pole = -(f_on_im*wfre + f_on_re*wfim)
        elseif(imre.lt.0)then ! imaginary part
        un_1_pole = (f_on_re*wfre - f_on_im*wfim)
*        print *,"im",un_1_pole,wfre,wfim,f_NN_on_re,f_NN
        endif

        endif
        
        if  (iflag.eq.2.or.iflag.eq.0) then   
************************************************************************
*    PV term
************************************************************************
        a1_z_re = 0.0
        a1_z_im = 0.0
        call A1_z(method,accuracy,uplimit,q_x,q_y,a1_z_re,a1_z_im)
*        call  f_NN_off(s,t_off,f_NN_off_re,f_NN_off_im,its)        

        if(imre.gt.0)then ! real part
        un_1_pv= -(f_on_re*a1_z_re - f_on_im*a1_z_im)
        elseif(imre.lt.0)then ! imaginary part
        un_1_pv= -(f_NN_off_re*a1_z_im + f_NN_off_im*a1_z_re)
        endif
************************************************************************
        endif
        
        un_1nd =(1.0/4.0)*q*(un_1_pole + un_1_pv)/(2.0*pi)**2 

        return
	end







