********************************************
* this is one after the fnn_fin version
* 18-Dec-03
* FIU, Miami
********************************************


    	subroutine f_NN_on(s,t,f_NN_onre,f_NN_onim,ins)
        call f_NN_diff(s,t,f_NN_onre_dif,f_NN_onim_dif,ins)
        f_NN_onre = f_NN_onre_dif
        f_NN_onim = f_NN_onim_dif
        return
        end
       

        subroutine f_NN_off(s,t,f_NN_offre,f_NN_offim,ins)
        call f_NN_diff(s,t,f_NN_onre_dif,f_NN_onim_dif,ins)
        f_NN_offre = f_NN_onre_dif
        f_NN_offim = f_NN_onim_dif
        return
        end
        
********************************************************************************
* Parameterization of NN scattering amplitude in diffrective form
********************************************************************************
    	subroutine f_NN_diff(s,t,f_NN_onre,f_NN_onim,ins)
        if(ins.eq.21.or.ins.gt.23)then          ! pn scattering
        sigma_tot = sigma_pn_tot(s) / 0.389385   ! Gev^{-2}
        an   = a_pn(s)
        expo = expo_pn(s,t)
        elseif(ins.eq.22)then                   ! pp scattering
        
        sigma_tot = sigma_pp_tot(s) / 0.389385   ! Gev^{-2}
        an   = a_pp(s)
        expo = expo_pp(s,t)
        endif        
        f_NN_onre = sigma_tot*an*expo
        f_NN_onim = sigma_tot*expo
        return
        end

        subroutine f_NN_diff_off(s,t,f_NN_offre,f_NN_offim,ins)
        if(ins.eq.21.or.ins.gt.23)then         ! pn scattering
        sigma_tot = sigma_pn_tot(s) / 0.389385   ! Gev^{-2}
        an   = a_pn(s)
        expo = expo_pn(s,t)
        elseif(ins.eq.22)then                  ! pp scattering
        sigma_tot = sigma_pp_tot(s) / 0.389385   ! Gev^{-2}
        an   = a_pp(s)
        expo = expo_pp(s,t)
        endif        

        f_NN_offre = sigma_tot*an*expo
        f_NN_offim = sigma_tot*expo
        return
        end


*************************************************************************
* exponential for pp scattering amplitude
*************************************************************************
        function expo_pp(s,t)
        common/par/pi,pm,pmp,pmn,tm,eb
        pcm2 = (s-4.*pm**2)/4. 
        sn_thkes2 = -t/4./pcm2
        if(sn_thkes2.gt.1.0)then
        expo_pp = 0.0
        return
        endif
  	expo_pp =  exp(bp(s)*t/2.0)
   	return
	end

**************************************************************************
* exponential for pn scattering amplitude
**************************************************************************
        function expo_pn(s,t)
        common/par/pi,pm,pmp,pmn,tm,eb
        pcm2 = (s-4.*pm**2)/4. 
        sn_thkes2 = -t/4./pcm2
        if(sn_thkes2.gt.1.0)then
*         write(6,*) "ERROR: function expo_pp: sn_thkes2 is gt 1 "
        expo_pn = 0.0
        return
        endif
  	expo_pn =  exp(bn(s)*t/2.0)
   	return
	end

*********************************************************************************
* parameterization of NN scattering amplitude based on SAID program
*********************************************************************************
    	subroutine f_NN_diff_said(is1,is2,is1p,is2p,
     &                           s,t,f_NN_onre,f_NN_onim,ins)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*                    spin polorized amplitudes in GeV-2
*             Normalization is: Im(f)=sigma_tot (so, 4*pi/pcm sits in f)
*input
* s                  --  (p_1^mu+p_2^mu)^2
* t                  --  (p_1^mu-p_3^mu)^2 
*
* is1,is2,is1p,is2p  -- initial and final spins of scattered nucleons
*
* ins                -- NN flag 21=pn->pn, 22 = pp->pp  
*output 
*f_NN_onre           -- real part of amplitude
*f_NN_onim           -- imaginary part of amplitude
*          when plab < 1.4 said amplitudes are involved
*          when plab > 1.4 old diffraction model is involved
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        dimension B(10)	 
        common/par/pi,pm,pmp,pmn,tm,eb
        ep = (s - 2.0*pm**2)/(2.0*pm)
        p = sqrt(ep**2-pm**2)
        pcm = sqrt(s-4*pm**2)/2.0 ! in GeV
        argum = (2.*t+s-4.*pm**2)/(s-4.*pm**2)      
        if(argum.gt.1.)   argum =  1.0
        if(argum.lt.-1.0) argum = -1.0
        acm_rad = acos(argum)
        acm  = (acm_rad/pi)*180.

***********************************************************************
      IF(abs(ins).eq.21.or.abs(ins).gt.23)THEN        !pn scattering
***********************************************************************
        if (p.le.1.4) then
          fMre = 0.0; fMim = 0.0
   
          call f_M(s,t,is1,is2,is1p,is2p,
     &                      ins,fMre,fMim,B)! Look in file Bystricky.f

*               output fMre and fMim are in sqrt(mbn)
*           Normalization is dsg=(Tr(fMre**2)+Tr(fMim**2))/4
*                     (dsg is dsigma/dOmega)
*             Now changing to normalization Im(f)=sigma_tot
*                     (Im(f) = Tr(fMim)/4)
        
          fMre = fMre/sqrt(0.389385)  ! sqrt(mbn) to GeV-1
          fMim = fMim/sqrt(0.389385)
          
          f_NN_onre = 4.*pi/pcm*fMre  ! in GeV-2
          f_NN_onim = 4.*pi/pcm*fMim  ! in GeV-2
          return
        else 
          f_NN_onre =0.0;  f_NN_onim = 0.0
          if(is1.eq.is1p.and.is2.eq.is2p) then   
            sigma_tot = sigma_pn_tot(s) / 0.389385   ! mbn to Gev^{-2}
            an   = a_pn(s)
            expo = expo_pn(s,t)
            f_NN_onre = sigma_tot*an*expo ! in GeV-2
            f_NN_onim = sigma_tot*expo    ! in GeV-2
          endif
! If not diagonal then automaticly f_NN_onre =0.0;  f_NN_onim = 0.0
          return

        endif

********************************************************************
      ELSEIF(ins.eq.22.or.ins.eq.-22)THEN                   ! pp scattering 
********************************************************************
        if (p.le.3.68) then
          fMre = 0.0; fMim = 0.0
          call f_M(s,t,is1,is2,is1p,is2p,
     &                      ins,fMre,fMim,B)! Look in file Bystricky.f

*             output fMre and fMim are in sqrt(mbn)
*             Normalization is dsg=(Tr(fMre**2)+Tr(fMim**2))/4
*                     (dsg is dsigma/dOmega)
*             Now changing to normalization Im(f)=sigma_tot
*                     (Im(f) = Tr(fMim)/4)
        
          fMre = fMre/sqrt(0.389385)  ! sqrt(mbn) to GeV-1
          fMim = fMim/sqrt(0.389385)

          f_NN_onre = 4.*pi/pcm*fMre  ! in GeV-2
          f_NN_onim = 4.*pi/pcm*fMim  ! in GeV-2
          return
        else 
          f_NN_onre =0.0;  f_NN_onim = 0.0
          if(is1.eq.is1p.and.is2.eq.is2p) then   
            sigma_tot = sigma_pp_tot(s) / 0.389385   ! mbn to Gev^{-2}
            ap   = a_pp(s)
            expo = expo_pp(s,t)
            f_NN_onre = sigma_tot*ap*expo ! in GeV-2
            f_NN_onim = sigma_tot*expo    ! in GeV-2
          endif
          return

        endif
      
      ENDIF

        return
        end


*************************************************************************************
*                       CHARGE EXCHANGE AMPLITUDE
*************************************************************************************
*************************************************************************************
*   Paremeterization of charcge exchange amplitude in the diffractive form
*       sigma_tot(i+alpha)exp(B/2*u)
*************************************************************************************
    	subroutine f_np_diff_chex(s,u,f_np_re_chex,f_np_im_chex)
        common/par/pi,pm,pmp,pmn,tm,eb

        sigma_tot=sqrt(16.*pi*dsgdu0_chex(s)/(1.+a_pn_chex(s)**2))
*         sigma_tot is in the sqrt(mbn)/GeV-1

        an   = a_pn_chex(s)
        expo = expo_pn_chex(s,u)

        f_np_re_chex = sigma_tot*expo*an/sqrt(0.389385) ! in GeV-2
        f_np_im_chex = sigma_tot*expo/sqrt(0.389385)    ! in GeV-2
        return
        end

        function expo_pn_chex(s,u)
        common/par/pi,pm,pmp,pmn,tm,eb
  	expo_pn_chex =exp(bn_chex(s)*u/2.0)
   	return
	end 

	function bn_chex(s)
        common/par/pi,pm,pmp,pmn,tm,eb	
        ep = (s - 2.0*pm**2)/(2.0*pm)
	p = sqrt(ep**2-pm**2)
        if(p.le.12.)then
        bn_chex =26.136 -8.8188*p+1.7759*p**2-0.15903*p**3
     &       +0.49825E-02*p**4
        else
        bn_chex = 4.5
        endif
*       bn_chex = 14.5
        return
        end
        function a_pn_chex(s)
        common/par/pi,pm,pmp,pmn,tm,eb
	ep = (s - 2.0*pm**2)/(2.0*pm)
	p = sqrt(ep**2-pm**2)
        a_pn_chex = - 5.0
        return
        end

        function dsgdu0_chex(s)
**********************************************************************
*  total charge-exchange pn cross section at full region  in (mb)
**********************************************************************
        common/par/pi,pm,pmp,pmn,tm,eb
	ep = (s - 2.0*pm**2)/(2.0*pm)
        p = sqrt(ep**2-pm**2)
         dsgdu0p2 = 0.0
        if(p.le.1.218986)then
        dsgdu0p2 =375.70-974.78*p+1524.0*p**2-970.34*p**3
     &       +214.08*p**4 

        elseif(p.le.10.89796)then
        dsgdu0p2 =257.34-95.761*p+19.494*p**2-1.7283*p**3
     &       +0.55984E-01*p**4

        elseif(p.le.105.)then

        dsgdu0p2 =90.592-1.1247*p+0.22597E-01*p**2-0.20237E-03*p**3
     &       + 0.63818E-06*p**4

        endif
        dsgdu0_chex =  dsgdu0p2/p**2    ! in mbn/GeV-2
        return
        end





********************************************************************************
* Parameterization of charge exchange amplitude based on SAID code
********************************************************************************
    	subroutine f_NN_diff_said_chex(is_1,is_2,is_1p,is_2p,
     &                           s,t,f_NN_onre,f_NN_onim)
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*                    spin polorized charge exchange amplitudes in GeV-2
*             Normalization is: Im(f)=sigma_tot (so, 4*pi/pcm sits in f)
*input
* s                  --  (p_1^mu+p_2^mu)^2
* t                  --  (p_1^mu-p_3^mu)^2 
*
* is1,is2,is1_,is2_  -- initial and final spins of scattered nucleons
*
*output 
*f_NN_onre           -- real part of chex amplitude
*f_NN_onim           -- imaginary part of chex amplitude
*          when plab < 1.4 said amplitudes are involved
*          when plab > 1.4 old diffraction model is involved
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        dimension B(10)	 
        common/par/pi,pm,pmp,pmn,tm,eb
        is1=is_1;is2=is_2;is1p=is_1p;is2p=is_2p;

        ep = (s - 2.0*pm**2)/(2.0*pm)
        p = sqrt(ep**2-pm**2)
*         pcm = pm*p/sqrt(s) ! in GeV

        pcm = sqrt(s-4*pm**2)/2.0 ! in GeV

        argum = (2.*t+s-4.*pm**2)/(s-4.*pm**2)      
        if(argum.gt.1.)   argum =  1.0
        if(argum.lt.-1.0) argum = -1.0
        acm_rad = acos(argum)
        acm  = (acm_rad/pi)*180.
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ SAID chex ~~~~~~~~~~~~~~~~~~~~~~~~~
        
        if (p.le.1.4) then
          fMre = 0.0; fMim = 0.0
   
          call f_M(s,t,is1,is2,is1p,is2p,
     &                      -22,fMre_pp_nc,fMim_pp_nc,B)
! Look in file Bystricky.f, -22 will use pp SAID amplitudes without coul. eff.
          call f_M(s,t,is1,is2,is1p,is2p,
     &                      21,fMre_pn,fMim_pn,B)

*           output fMre and fMim are in sqrt(mbn)
*           Normalization is dsg=(Tr(fMre**2)+Tr(fMim**2))/4
*           (dsg is dsigma/dOmega)
*           Now changing to normalization Im(f)=sigma_tot
*           (Im(f) = Tr(fMim)/4)
        
       fMre = (fMre_pp_nc-fMre_pn)/sqrt(0.389385)  ! sqrt(mbn) to GeV-1
       fMim = (fMim_pp_nc-fMim_pn)/sqrt(0.389385)
*           fMre = (fMre_pp_nc)/sqrt(0.389385)!/2.  ! sqrt(mbn) to GeV-1
*           fMim = (fMim_pp_nc)/sqrt(0.389385)!/2.
         
          f_NN_onre = 4.*pi/pcm*fMre  ! in GeV-2
          f_NN_onim = 4.*pi/pcm*fMim  ! in GeV-2
          return

*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Difractive chex ~~~~~~~~~~~~~~~~~~~~~~~~~~

        else 
          f_NN_onre =0.0;  f_NN_onim = 0.0
          if(is1.eq.is1p.and.is2.eq.is2p) then   
!                             PN
            sigma_tot = sigma_pn_tot(s) / 0.389385   ! mbn to Gev^{-2}
            an   = a_pn(s)
            expo = expo_pn(s,t)
            f_NN_onre_pn = sigma_tot*an*expo ! in GeV-2
            f_NN_onim_pn = sigma_tot*expo    ! in GeV-2
!                            PP
            sigma_tot = sigma_pp_tot(s) / 0.389385   ! mbn to Gev^{-2}
            an   = a_pp(s)
            expo = expo_pp(s,t)
            f_NN_onre_pp = sigma_tot*an*expo ! in GeV-2
            f_NN_onim_pp = sigma_tot*expo    ! in GeV-2
!                           CHEX = PP-PN
            f_NN_onre = f_NN_onre_pp - f_NN_onre_pn
            f_NN_onim = f_NN_onim_pp - f_NN_onim_pn
          endif  ! end for diagonal terms
! If not diagonal then automaticly f_NN_onre =0.0;  f_NN_onim = 0.0
        return
        endif
        return
        end
